/*
 * Copyright (C) 2019 Dennis Schneider
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "amish_cmd_flags.h"

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "global_flags.h"

void amish_cmd_flags(amish_cmd_arg *ca) {
	ca->ret.val = 0;
	char *in = ca->input;
	char* out = ca->output;
	uint8_t len = 0;
	uint8_t arg = ca->arg;
	uint8_t state = ((uint32_t8)ca->state).b1;

	if (arg == CMD_FLAG_SECONDS) {
		skip_whitespaces(in);
		if(*in) {
			int8_t val = amish_parse_boolean(in);
      if(val == -1)
		    len = sprintf_P(out, PSTR("Invalid argument."));
      else
        global_flags.hide_seconds  = !val;
		}
		len += sprintf_P(out + len, PSTR("Show seconds: %S"), global_flags.hide_seconds ? PSTR("no") : PSTR("yes"));
	}
	state++;
	ca->state.b1 = state;
	ca->ret.len = len;
}

