/*
 * Copyright (C) 2009-2011 Dennis Schneider
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *		notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *		notice, this list of conditions and the following disclaimer in the
 *		documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "config.h"
#include "amish.h"
#include "amish_cmd_main.h"
#include "main.h"



void amish_cmd_main(amish_cmd_arg *ca) {
	ca->ret.val = 0;
	char* out = ca->output;
	uint8_t len = 0;
	uint8_t state = ((uint32_t8)ca->state).b1;

	ca->ret.call_again = 1;
	switch(state) {
	case 0:
		len = sprintf_P(out,PSTR("HF status:\r\n\tSignal level: -%hhu dBm"),
			s_meter_level);
		break;
	case 1:
		len = sprintf_P(out, PSTR("\tPLL %Slocked, phase: %u/1024"),
			IS_SET(PIN_LOCKED)? PSTR("un"):PSTR(""), pll_phase);
		break;
	case 2:
		len = sprintf_P(out, PSTR("\tSupply voltage: %hhu.%hhu V"),
			supply_voltage/10, supply_voltage%10);
		ca->ret.call_again = 0;
		break;
	}
	state++;
	ca->state.b1 = state;
	ca->ret.len = len;
}

