/*
 * Copyright (C) 2009-2010 Dennis Schneider
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _AMISH_CMD_UIP_H
#define _AMISH_CMD_UIP_H

#include "config.h"
#include "amish.h"

/*
 * Bits:
 * 0,1: field type (IP,GW,MASK,ETHER)
 * 2: 0: read, 1: write
 * 3: data type (dot-quatted, colon-separated)
 */
#define CMD_UIP_FIELD (3)
#define CMD_UIP_FIELD_IP 0
#define CMD_UIP_FIELD_GW 1
#define CMD_UIP_FIELD_MASK 2
#define CMD_UIP_FIELD_ETHER 3
#define CMD_UIP_TYPE   (1<<2)
#define CMD_UIP_DQUAD  (0<<2)
#define CMD_UIP_COLSEP (1<<2)
#define CMD_UIP_GET_IP    (CMD_UIP_FIELD_IP    | CMD_UIP_DQUAD)
#define CMD_UIP_SET_IP    (CMD_UIP_FIELD_IP    | CMD_UIP_DQUAD)
#define CMD_UIP_GET_GW    (CMD_UIP_FIELD_GW    | CMD_UIP_DQUAD)
#define CMD_UIP_SET_GW    (CMD_UIP_FIELD_GW    | CMD_UIP_DQUAD)
#define CMD_UIP_GET_MASK  (CMD_UIP_FIELD_MASK  | CMD_UIP_DQUAD)
#define CMD_UIP_SET_MASK  (CMD_UIP_FIELD_MASK  | CMD_UIP_DQUAD)
#define CMD_UIP_GET_ETHER (CMD_UIP_FIELD_ETHER | CMD_UIP_COLSEP)
#define CMD_UIP_SET_ETHER (CMD_UIP_FIELD_ETHER | CMD_UIP_COLSEP)

void amish_cmd_uip(amish_cmd_arg*);

#endif
